<?php

namespace ACL\Controllers;

use ACL\Traits\TResponse;
use Exception;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use ACL\Helpers\Instances\InstanceProvider;
use ACL\Util\AclUtilities;
use ACL\Services\Organizacao as OrganizacaoService;

class Organizacao {

    use TResponse;

    /**
     * @var OrganizacaoService
     */
    private $organizacaoService;

    public function __construct(OrganizacaoService $organizacaoService)
    {
        $this->organizacaoService = $organizacaoService;
    }

    public function findOrganizacao(Request $request, Response $response)
    {
        try {
            $organization = $this->organizacaoService->findOrganizacao();
            $this->sendResponse($organization, 200);
        } catch (Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
