/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_EMPR                                                     */
/* Tabela : EMPRESA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_EMPR
BEFORE INSERT OR UPDATE OR DELETE
ON EMPRESA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUEMPR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDEMPRESA,0) <> NVL(:NEW.CDEMPRESA,0))       OR
         (NVL(:OLD.NMEMPRESA,0) <> NVL(:NEW.NMEMPRESA,0))       OR
         (NVL(:OLD.VRPEMOREMPR,0) <> NVL(:NEW.VRPEMOREMPR,0))   OR
         (NVL(:OLD.CDCENTCUST,0) <> NVL(:NEW.CDCENTCUST,0))     OR
         (NVL(:OLD.NMRAZSOCEMPR,0) <> NVL(:NEW.NMRAZSOCEMPR,0)) OR
         (NVL(:OLD.NRINSJUREMPR,0) <> NVL(:NEW.NRINSJUREMPR,0)) OR
         (NVL(:OLD.IDTPIJUREMPR,0) <> NVL(:NEW.IDTPIJUREMPR,0)) OR
         (NVL(:OLD.CDINSCESTA,0) <> NVL(:NEW.CDINSCESTA,0))     OR
         (NVL(:OLD.CDINSCMUNI,0) <> NVL(:NEW.CDINSCMUNI,0))     OR
         (NVL(:OLD.CDCNAE,0) <> NVL(:NEW.CDCNAE,0))               OR
         (NVL(:OLD.VRPEMULEMPR,0) <> NVL(:NEW.VRPEMULEMPR,0)) THEN
         :NEW.DTULTATUEMPR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('EMPRESA', '', 'CDEMPRESA='||:OLD.CDEMPRESA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE EMPRESA MODIFY DTULTATUEMPR DEFAULT SYSDATE
/

UPDATE EMPRESA SET DTULTATUEMPR = SYSDATE WHERE DTULTATUEMPR IS NULL
/

